/*                               -*- Mode: C -*- 
 * default-user-external_f.h -- 
 * 
 * Copyright (c) 1991-2013 Francois Felix Ingrand.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */


/* 
 * This file will contain the functions provided to the user and 
 * called from the kernel. For example, if the user want to get 
 * statistics on FACTS or GOALS, or database operation, we could put 
 * in the kernel code a function call pointing to a function defined 
 * here. By default this function would do nothing, but if the user 
 * wish it would perform some operations.
 */


#ifdef  __cplusplus
extern "C"  {
#endif
PBoolean intention_list_sort_by_priority(Intention *i1, Intention *i2);
PBoolean intention_list_sort_by_time(Intention *i1, Intention *i2);
PBoolean intention_list_sort_by_priority_time(Intention *i1, Intention *i2);

Intention_List intention_scheduler_time_sharing(Intention_List l);
Intention_List intention_scheduler_time_sharing_with_sort_predicate(Intention_List l);

void start_kernel_hook(char *name);

void end_kernel_hook();

#ifdef  __cplusplus
}
#endif

