/*                               -*- Mode: C -*- 
 * slistPack-pub.h -- Simple list header.
 * 
 * Copyright (c) 1991-2013 Francois Felix Ingrand.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef INCLUDE_slistPack_pub
#define INCLUDE_slistPack_pub

typedef char (*SL_PFC)(const void *, const void *);	/* pointer to func returning int */
typedef int (*SL_PFI)(const void *);	/* pointer to func returning int */
typedef int (*SL_PFI2)(const void *, const void *);
typedef int (*SL_PFI3)(const void *, const void *, const void *);
typedef int (*SL_PFI4)(const void *, const void *, const void *, const void *);
typedef void *(*SL_PFPV)(const void *); /* pointer to func taking void * returning void * */
typedef void *(*SL_PFPV2)(const void *, const void *);
typedef void *(*SL_PFPV3)(const void *, const void *, const void *);

typedef struct simple_list  Slist, *OPRS_LIST; /* OPRS_LIST is here for upward compatibility... */

typedef Slist Squeue;

#ifndef NULL
#define NULL    0
#endif

#define NULLSlist ((Slist *) 0)
#define NULLSnode ((Snode *) 0)

typedef void *OPRS_NODE;

#endif
